# RESCORM

RESCORM is a boilerplate for creating SCORM-compliant React applications.


# Features

- [x] ECMAScript 6 and JSX support
- [x] React 16.0.0
- [x] React Router v4
- [x] Redux
- [x] Redux-thunk
- [x] Redux DevTools extension
- [x] SCORM 1.2 and SCORM 2004 4th Editon support
- [x] Webpack (v.3.6.0) and Webpack Dev Server (v.2.8.2)
- [x] Hot Module Replacement using [react-hot-loader](https://github.com/gaearon/react-hot-loader)
- [x] Component testing using [Enzyme](https://github.com/airbnb/enzyme) and [Jest](https://facebook.github.io/jest)
- [x] ES6 linting with continuous linting on file change
- [x] Separate CSS stylesheets generation
- [x] SASS support
- [x] Export Separate Vendor Files
- [x] I18n  
  
  
# Installation and documentation

Visit the RESCORM [wiki](https://github.com/agordillo/RESCORM/wiki) to see all the available documentation of the boilerplate including installation instructions. 
 
 
# Discussion and contribution
  
Feel free to raise an issue or send us a message at [GitHub](https://github.com/agordillo/RESCORM/issues).  


# License

RESCORM is available under MIT License.

This boilerplate has been developed based on [ES6 React boilerplate using Webpack](https://github.com/KleoPetroff/react-webpack-boilerplate) and [react-iweb-boilerplate](https://github.com/sonsoleslp/react-iweb-boilerplate).

